version = "1.0"

-- splash
screen:blit(0, 0, Image.load("TITLE.JPG"))
screen:print(10, 255, version, Color.new(255,255,255))
screen.flip()
System.sleep(200)

dofile("init.lua")

-- init WLAN and choose connection config
Wlan.init()
wlan_configs = Wlan.getConnectionConfigs()

-- show options on first run
if app_connection == 0 or app_connection > table.getn(wlan_configs) then
  first_run = true
  app_connection = 1
  wlan_tmp_connection = app_connection
  show_options()
else
  wlan_tmp_connection = app_connection
end

if net_offline ~= true then
  online = Wlan.useConnectionConfig(app_connection)
  if first_run then
    dl_feeds() -- update feeds on first start
  end
  -- Wlan.useConnectionConfig(app_connection)
  if not online then
    screen:blit(0, 0, theme_bg)
    screen:print(0, 0, "Unable to connect!", Black)
    screen.waitVblankStart()
    screen.flip()
    System.sleep(5000)
  end
end

-- update on start
if app_feed_update_on_start and net_offline ~= true then
  dl_feeds()
end

updatefeeds()
  
while not Controls.read():start() do
  pad = Controls.read()
    
  if pad:up() then
    rss_article_line_startindex = 1

    -- decrement article
    if myfeeds[rss_feed_selected].items ~= nil then
      if rss_article_selected > 1 then
        rss_article_selected = rss_article_selected - 1
      end
        
      if rss_article_selected < rss_article_index then
        rss_article_index = rss_article_index - 1
      end
    end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end
    
    -- System.sleep(50)
  end
  
  if pad:down() then
    rss_article_line_startindex = 1

    -- increment article
    if myfeeds[rss_feed_selected].items ~= nil then
      if rss_article_selected < table.getn(myfeeds[rss_feed_selected].items) then
        rss_article_selected = rss_article_selected + 1
      end
      
      if rss_article_selected > rss_article_index + rss_articles_show - 1 then
        rss_article_index = rss_article_index + 1
      end
    end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end

    -- System.sleep(50)
  end

  if pad:analogY() < -pad_deadzone then
    -- scroll article up
    if current_story ~= nil then
      if rss_article_line_startindex > 1 then
        rss_article_line_startindex = rss_article_line_startindex - 1
      end
    end

    -- prevent power save
    System.powerTick()

  end
  
  if pad:analogY() > pad_deadzone then
    -- scroll article down
    if current_story ~= nil then
      if rss_article_line_startindex + rss_article_maxlines <= table.getn(current_story) then
        rss_article_line_startindex = rss_article_line_startindex + 1
      end
    end

    -- prevent power save
    System.powerTick()

  end
  
  if pad:l() then
    rss_article_selected = 1
    rss_article_index = 1
    rss_article_line_startindex = 1

    -- decrement selected feed
    if rss_feed_selected <= 1 then
      rss_feed_index = table.getn(rss_feeds.Data) - rss_articles_show + 1
      rss_feed_selected = table.getn(rss_feeds.Data)
    else
      rss_feed_selected = rss_feed_selected - 1
    end
    if rss_feed_selected < rss_feed_index then
      rss_feed_index = rss_feed_index - 1
    end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end

    System.sleep(50)
  end

  if pad:r() then
    rss_article_selected = 1
    rss_article_index = 1
    rss_article_line_startindex = 1

    -- increment selected feed
    if rss_feed_selected >= table.getn(rss_feeds.Data) then
      rss_feed_index = 1
      rss_feed_selected = 1
    else
      rss_feed_selected = rss_feed_selected + 1
    end
    if rss_feed_selected > rss_feed_index + rss_feeds_show - 1 then
      rss_feed_index = rss_feed_index + 1
    end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end

    System.sleep(50)
  end

  if pad:triangle() then
    rss_article_selected = 1
    rss_article_index = 1
    rss_article_line_startindex = 1
     if net_offline ~= true then
       dl_feed(rss_feed_selected)
     end
     updatefeed(rss_feed_selected)
  end

  if pad:square() then
     show_help()
  end
  
  if pad:select() then
    show_options()
  end

  draw_chooser()    
  screen:blit(0, 0, offscreen)
  screen.waitVblankStart()
  screen.flip()
  
end

Wlan.term()