function show_help()
  System.sleep(200)
  while not Controls.read():select() do
    pad = Controls.read()
    if pad:square() then
       break
    end
    draw_help_keys()
    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
  end
  System.sleep(200)
end

function show_options()
  

   -- get available themes
   System.currentDirectory(themedir)
   local tmpdir = System.listDirectory()
   local avail_themes = {}
   local themecount = 0
   local seltheme = 0
   for idx,file in tmpdir do
      if file.directory then
        if string.sub(file.name,1,1) ~= "." and string.sub(file.name,1,2) ~= ".." then
          themecount = themecount + 1
          avail_themes[themecount] = string.lower(file.name)
          if string.lower(file.name) == string.lower(theme_selected) then
            seltheme = themecount
          end
        end
      end
   end

  System.currentDirectory(app_current_dir)

  System.sleep(200)
  while not Controls.read():select() do
    pad = Controls.read()

    if pad:up() then
      if options_selected > 1 then
        options_selected = options_selected - 1
      end
      System.sleep(50)
    end
    if pad:down() then
      if options_selected < 6 then
        options_selected = options_selected + 1
      end
      System.sleep(50)
    end
    if pad:left() then
      if options_selected == 2 then
        if wlan_tmp_connection > 1 then
          wlan_tmp_connection = wlan_tmp_connection - 1
        else
          wlan_tmp_connection = table.getn(wlan_configs)
        end
      end
      if options_selected == 3 then
        if seltheme > 1 then
          seltheme = seltheme - 1
        else
          seltheme = themecount
        end
        theme_selected = string.lower(avail_themes[seltheme])
        System.currentDirectory(themedir .. theme_selected .. "/")
        dofile(theme_selected .. ".lua")
        System.currentDirectory(app_current_dir)
      end
      if options_selected == 5 then
        if net_timeout > 1 then
          net_timeout = net_timeout - 1
        else
          net_timeout = 30
        end
      end
      System.sleep(50)
    end
    if pad:right() then
      if options_selected == 2 then
        if wlan_tmp_connection < table.getn(wlan_configs) then
          wlan_tmp_connection = wlan_tmp_connection + 1
        else
          wlan_tmp_connection = 1
        end
      end
      if options_selected == 3 then
        if seltheme < themecount then
          seltheme = seltheme + 1
        else
          seltheme = 1
        end
        theme_selected = avail_themes[seltheme]
        System.currentDirectory(themedir .. theme_selected .. "/")
        dofile(theme_selected .. ".lua")
        System.currentDirectory(app_current_dir)
      end
      if options_selected == 5 then
        if net_timeout < 30 then
          net_timeout = net_timeout + 1
        else
          net_timeout = 1
        end
      end
      System.sleep(50)
    end
    if pad:cross() or pad:circle() then
      if options_selected == 1 then
          dl_feeds()
          updatefeeds()
          break
      end
      if options_selected == 4 then
        app_feed_update_on_start = not app_feed_update_on_start
      end
      if options_selected == 6 then
        net_offline = not net_offline
      end
      System.sleep(50)
    end
    if pad:start() then
      break
    end
    draw_chooser()
    draw_options()
    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
  end

  -- save options
  optionsfile = io.open("options.lua","w")
  optionsfile:write("app_connection = " .. app_connection .. "\n")
  if app_feed_update_on_start == true then
    optionsfile:write("app_feed_update_on_start = true\n")
  else
    optionsfile:write("app_feed_update_on_start = false\n")
  end  
  if app_feed_update_on_start == true then
    optionsfile:write("app_check_for_update = true\n")
  else
    optionsfile:write("app_check_for_update = false\n")
  end
  optionsfile:write("app_theme = " .. '"' ..  theme_selected .. '"' .. "\n")
  optionsfile:write("net_timeout = " .. net_timeout .. "\n")
  if net_offline == true then  
    optionsfile:write("net_offline = true\n")
  else
    optionsfile:write("net_offline = false\n")
  end
  optionsfile:close()

  if wlan_tmp_connection ~= app_connection and net_offline ~= true then
    app_connection = wlan_tmp_connection
    Wlan.term()
    Wlan.init()
    Wlan.useConnectionConfig(app_connection)
  elseif net_offline == true then
    Wlan.term()
  else
    -- changed offline browsing to false, using same conn
    Wlan.init()
    Wlan.useConnectionConfig(app_connection)
  end
  
end


function get_formatted_lines(text, MaxLineLength)
  -- THANKS TO ASP.NET for this Word Wrap function!! (WHAT A PAIN IN THE ASS THIS GAVE ME)
       strWrappedText=""        -- Result storage
       intLengthOfInput = 0      -- Length of original

       CurrentPosition = 0      -- Where we're at now
       CurrentLineStart = 0     -- Where the current line starts
       PositionOfLastSpace = 0    -- Last space we saw

       -- Get this once so we don't have to keep checking
       intLengthOfInput = string.len(text)

       -- Start both of these at the beginning
       CurrentPosition = 1
       CurrentLineStart = 1
     
     alines = {}
     linecount = 0

       -- Loop through until we get to the end
       while CurrentPosition < intLengthOfInput do
            -- If the current position is a space, make a note of
            -- its location for later use.
            if string.sub(text, CurrentPosition, CurrentPosition) == " " then
                 PositionOfLastSpace = CurrentPosition
            end

            
            -- If we're at what should be the end of a line, we go back
            -- to the last space we saw and cut the line there.
            --if CurrentPosition == CurrentLineStart + MaxLineLength or string.sub(text, CurrentPosition, CurrentPosition) == "\n" or string.sub(text, CurrentPosition, CurrentPosition) == "\r" then
			if CurrentPosition == CurrentLineStart + MaxLineLength then
				-- Append this latest line to our result, attempting to remove whitespace lines
				--newline = string.trimnewlines(string.trim(string.sub(text, CurrentLineStart, CurrentLineStart + (PositionOfLastSpace - CurrentLineStart))))
				newline = string.sub(text, CurrentLineStart, CurrentLineStart + (PositionOfLastSpace - CurrentLineStart))
							     
				 linecount = linecount + 1
				 
                 if linecount >= 2 then
				   if string.len(alines[linecount - 1]) == 0 and string.len(newline) == 0 then
				     linecount = linecount - 1
				   end
				 end
				 
				 alines[linecount] = newline
				 -- debug
				 --if linecount >= 2 then
				 --  alines[linecount] = alines[linecount] .. "(" .. string.len(alines[linecount - 1]) .. ")" .. "(" .. string.len(newline) .. ")"
				 --end

                 -- Reset the next line's starting point to the point we
                 -- used for the last one's end + 1.
                 CurrentLineStart = PositionOfLastSpace + 1

                 -- Remove any leading spaces that might mess up our
                 -- character count.  If you want to just pull off one,
                 -- switch this to a simple If conditional instead of
                 -- looping.
                 while string.sub(text, CurrentLineStart, CurrentLineStart) == " " do
                     CurrentLineStart = CurrentLineStart + 1
                 end
			elseif string.sub(text, CurrentPosition, CurrentPosition) == "\n" or string.sub(text, CurrentPosition, CurrentPosition) == "\r" then
				newline = string.sub(text, CurrentLineStart, CurrentPosition - 1)
				linecount = linecount + 1
				if linecount >= 2 then
				   if string.len(alines[linecount - 1]) == 0 and string.len(newline) == 0 then
				     linecount = linecount - 1
				   end
				end
				alines[linecount] = newline
				CurrentLineStart = CurrentPosition + 1
            end

            -- Increment our location indicator.
            CurrentPosition = CurrentPosition + 1
       end

       -- Since the loop ends before we add the remaining text,
       -- add remaining text as the last line.
       linecount = linecount + 1
       alines[linecount] = string.trim(string.sub(text, CurrentLineStart))
    
       -- Return our result to the calling line.
       return alines
end



function updatefeeds()
  if table.getn(rss_feeds.Data) >= 1 then
    
    for i = 1, table.getn(rss_feeds.Data) do
        current_update = i
        draw_update()
        myxml = parseXML(feeddir .. "rss" .. i ..".tmp")
        cinfo[i], myfeeds[i] = parseCorrectType(myxml)
    end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end
  end
end

function updatefeed(index)
  if rss_feeds.Data[index] ~= nil then
     current_update = index
     draw_update()
     myxml = parseXML(feeddir .. "rss" .. index ..".tmp")
     cinfo[index], myfeeds[index] = parseCorrectType(myxml)
  end

    -- get new story
    if myfeeds[rss_feed_selected].items ~= nil and myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
      current_story = get_formatted_lines(myfeeds[rss_feed_selected].items[rss_article_selected].description, rss_article_maxchars)
    end
end


function get_xml_table(file)
  myxml = {}
  
  lines = io.lines(file)
  local tagtitle = ""
  local tagdata = ""
  local itemcount = 0
  local count = 0   
  
  for line in lines do
    if string.len(line) > 0 then
      for i = 1, string.len(line) do
        if string.sub(line, i, i) == "<" and string.sub(line, i + 1, i + 1) ~= "/" then
          -- start tag
          while string.sub(line, i + 1, i + 1) ~= ">" and i < string.len(line) do
            i = i + 1
            tagtitle = tagtitle .. string.sub(line, i, i)
          end
          i = i + 1
          while i < string.len(line) do
            if string.sub(line, i + 1, i + 2) ~= "</" then
              i = i + 1
              tagdata = tagdata .. string.sub(line, i, i)
            else
              break
            end
          end
          
        -- reached end of tag name
        if tagtitle ~= nil then
      count = count + 1
      myxml[count] = { [tagtitle] = tagdata }
        end
        
         -- if tagtitle == "title" then
           tagtitle = ""
           tagdata = ""
        end
      end
    end
  end
  return myxml
end


function get_ini_data(initable, index, item)
  return initable.Data[index][data_name]
end

function get_ini_table(file)
  myini = {}
  myini.Data = {}
  
  data_title = nil
  
  lines = io.lines(file)
  
  itemcount = 0
  keycount = 0
  for line in lines do
    if string.sub(line, 1, 1) == "[" then
      -- and string.sub(line, string.len(line) - 1, string.len(line) - 1) == "]"
      -- found item header, store it (started and ended with [ / ]
      data_title = string.sub(line, 2, string.len(line) - 1)
      if data_title ~= nil then
        itemcount = itemcount + 1
        keycount = 0
        --screen:fontPrint(monoSpaced, 180, 75 + (itemcount * 15), data_title, black)
        myini.Data[itemcount] = {}
        myini.Data[itemcount].Title = data_title
      end
    else
      -- straight key=value line ??
      a, b = string.find(line, "=")
        
      if a ~= nil then
        data_name = string.sub(line, 1, a - 1)
        data_value = string.sub(line, a + 1, string.len(line))
        
        if data_title ~= nil then
          -- data info found, split it and store it
          keycount = keycount + 1
          table.insert(myini.Data[itemcount], data_name)
          myini.Data[itemcount][data_name] = data_value
        else
          -- settings / variables found, not for data storage
          myini[data_name] = data_value
        end
      end
    end
  end
  return myini
end