

function draw_options()
  offscreen:blit(options_loc.x, options_loc.y, theme_options_title)

  for opts = 1, 6 do
    if opts == options_selected then
      if opts == 4 then
        -- update feeds on start,
        if app_feed_update_on_start then
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkon_sel)
        else
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkoff_sel)
        end
      elseif opts == 6 then
        -- net_offline
        if net_offline then
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkon_sel)
        else
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkoff_sel)
        end
      else
        -- generic bg for option
        offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_sel)
      end
    else
      if opts == 4 then
        -- update feeds on start
        if app_feed_update_on_start then
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkon_unsel)
        else
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkoff_unsel)
        end
      elseif opts == 6 then
        -- net_offline
        if net_offline then
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkon_unsel)
        else
          offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_checkoff_unsel)
        end
      else
        -- generic bg for option
        offscreen:blit(options_loc.x, options_loc.y + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), theme_options_unsel)
      end
    end

    if opts == 1 then
      -- update all feeds
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Update All Feeds", Black)
    elseif opts == 2 then
      -- sel conn
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Conn: " .. wlan_configs[wlan_tmp_connection], Black)
    elseif opts == 3 then
      -- theme select
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Theme: " .. theme_selected, Black)
    elseif opts == 4 then
      -- update feeds on start
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Update on Startup: " .. boolToText(app_feed_update_on_start), Black)
    elseif opts == 5 then
      -- timeout
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Net Timeout: " .. net_timeout, Black)
    elseif opts == 6 then
      -- offline
      offscreen:print(options_loc.x + 25, options_loc.y + 10 + theme_options_title:height() + ((opts - 1) * theme_options_sel:height()), "Offline: " .. boolToText(net_offline), Black)
    end
  end     
end

function draw_help_keys()

  help_triangle_text = "Update Feed"
  help_l_text = "Prev Feed"
  help_r_text = "Next Feed"
  help_dpad_text = "Change Article"
  help_analog_text = "Scroll Article"
  help_square_text = "Show/Hide Help"

  offscreen:blit(keys_loc.x, keys_loc.y, theme_keys_bg)

  -- triangle  
  offscreen:blit(keys_loc.x + keys_triangle_offset.x, keys_loc.y + keys_triangle_offset.y, theme_keys_triangle_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_triangle_text_offset.x, keys_loc.y + keys_triangle_text_offset.y, help_triangle_text, keys_color)

  -- l  
  offscreen:blit(keys_loc.x + keys_l_offset.x, keys_loc.y + keys_l_offset.y, theme_keys_l_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_l_text_offset.x, keys_loc.y + keys_l_text_offset.y, help_l_text, keys_color)
  
  -- r  
  offscreen:blit(keys_loc.x + keys_r_offset.x, keys_loc.y + keys_r_offset.y, theme_keys_r_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_r_text_offset.x, keys_loc.y + keys_r_text_offset.y, help_r_text, keys_color)

  -- dpad
  offscreen:blit(keys_loc.x + keys_dpad_offset.x, keys_loc.y + keys_dpad_offset.y, theme_keys_dpad_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_dpad_text_offset.x, keys_loc.y + keys_dpad_text_offset.y, help_dpad_text, keys_color)

  -- analog 
  offscreen:blit(keys_loc.x + keys_analog_offset.x, keys_loc.y + keys_analog_offset.y, theme_keys_analog_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_analog_text_offset.x, keys_loc.y + keys_analog_text_offset.y, help_analog_text, keys_color)

  -- square 
  offscreen:blit(keys_loc.x + keys_square_offset.x, keys_loc.y + keys_square_offset.y, theme_keys_square_on)
  offscreen:fontPrint(keys_font, keys_loc.x + keys_square_text_offset.x, keys_loc.y + keys_square_text_offset.y, help_square_text, keys_color)
  
end


function draw_chooser()

  offscreen:blit(0, 0, theme_bg)

  drawfeeds()

  if myfeeds[rss_feed_selected] ~= nil and myfeeds[rss_feed_selected].items ~= nil then
    drawarticles()
    drawarticle()
  else
    offscreen:blit(rss_error_loc.x, rss_error_loc.y, theme_fchooser_error)
    offscreen:fontPrint(rss_error_font, rss_error_loc.x + rss_error_offset.x, rss_error_loc.y + rss_error_offset.y, "Unable to parse feed!", rss_error_color)
  end

    -- help
    offscreen:blit(rss_help_loc.x, rss_help_loc.y, theme_keys_square_on)
    offscreen:fontPrint(keys_font, rss_help_loc.x + rss_help_text_offset.x, rss_help_loc.y + rss_help_text_offset.y, "Help", rss_help_color)
 
end


function drawfeeds()

    -- draw feed chooser
    offscreen:blit(rss_feeds_title_loc.x, rss_feeds_title_loc.y, theme_fchooser_title)
    
    -- blit feeds
    local current = 0
    for i = rss_feed_index, rss_feed_index + rss_feeds_show - 1 do
      if rss_feeds.Data[i] ~= nil then
        if i == rss_feed_selected then
          offscreen:blit(rss_feeds_loc.x + (current * rss_feeds_spacing.x), rss_feeds_loc.y + (current * rss_feeds_spacing.y), theme_fchooser_sel)
          offscreen:fontPrint(rss_feeds_font, rss_feeds_loc.x + rss_feeds_offset.x + (current * rss_feeds_spacing.x), rss_feeds_loc.y + rss_feeds_offset.y + (current * rss_feeds_spacing.y), string.sub(rss_feeds.Data[i].Title, 1, rss_feeds_maxchars), rss_feeds_selected_color)
        else
          offscreen:blit(rss_feeds_loc.x + (current * rss_feeds_spacing.x), rss_feeds_loc.y + (current * rss_feeds_spacing.y), theme_fchooser_unsel)
          offscreen:fontPrint(rss_feeds_font, rss_feeds_loc.x + rss_feeds_offset.x + (current * rss_feeds_spacing.x), rss_feeds_loc.y + rss_feeds_offset.y + (current * rss_feeds_spacing.y), string.sub(rss_feeds.Data[i].Title, 1, rss_feeds_maxchars), rss_feeds_color)
        end
        current = current + 1
      end
    end
    
    offscreen:blit(rss_feeds_footer_loc.x, rss_feeds_footer_loc.y, theme_fchooser_footer)
    offscreen:fontPrint(rss_feeds_footer_font, rss_feeds_footer_loc.x + rss_feeds_footer_offset.x, rss_feeds_footer_loc.y + rss_feeds_footer_offset.y, "Feed #" .. rss_feed_selected .. "/" .. table.getn(rss_feeds.Data), rss_feeds_misc_color)

end

function drawarticles()

-- draw article chooser
  offscreen:blit(rss_articles_title_loc.x, rss_articles_title_loc.y, theme_achooser_title)

    current = 0
    for i = rss_article_index, rss_article_index + rss_articles_show - 1 do
      current = current + 1
        if i == rss_article_selected then
          offscreen:blit(rss_articles_loc.x + (current * rss_articles_spacing.x), rss_articles_loc.y + (current * rss_articles_spacing.y), theme_achooser_sel)
          offscreen:fontPrint(rss_articles_title_font, rss_articles_loc.x + rss_articles_offset.x + (current * rss_articles_spacing.x), rss_articles_loc.y + rss_articles_offset.y + (current * rss_articles_spacing.y), string.sub(myfeeds[rss_feed_selected].items[i].title, 1, rss_articles_title_maxchars), rss_articles_selected_color)
        else
          offscreen:blit(rss_articles_loc.x + (current * rss_articles_spacing.x), rss_articles_loc.y + (current * rss_articles_spacing.y), theme_achooser_unsel)
          offscreen:fontPrint(rss_articles_title_font, rss_articles_loc.x + rss_articles_offset.x + (current * rss_articles_spacing.x), rss_articles_loc.y + rss_articles_offset.y + (current * rss_articles_spacing.y), string.sub(myfeeds[rss_feed_selected].items[i].title, 1, rss_articles_title_maxchars), rss_articles_color)
        end
    end

    offscreen:blit(rss_articles_footer_loc.x, rss_articles_footer_loc.y, theme_achooser_footer)
    offscreen:fontPrint(rss_articles_footer_font, rss_articles_footer_loc.x + rss_articles_footer_offset.x, rss_articles_footer_loc.y + rss_articles_footer_offset.y, "Article # " .. rss_article_selected .. "/" .. table.getn(myfeeds[rss_feed_selected].items), rss_articles_misc_color)

  if rss_feeds.Data[rss_feed_selected].lastupdate ~= nil then
    -- offscreen:print(0, 0, rss_feeds.Data[rss_feed_selected].lastupdate, rss_articles_misc_color)
  end

end

function drawarticle()

  offscreen:blit(rss_article_bg_loc.x, rss_article_bg_loc.y, theme_article_bg)
  
  -- story
  if myfeeds[rss_feed_selected].items[rss_article_selected].description ~= nil then
    offscreen:fontPrint(rss_article_title_font, rss_article_title_loc.x, rss_article_title_loc.y, myfeeds[rss_feed_selected].items[rss_article_selected].title, rss_article_title_color)
    
	local shown = 0
    for i = 0, rss_article_maxlines - 1 do
      if current_story[rss_article_line_startindex + i] ~= nil then
        offscreen:fontPrint(rss_article_font, rss_article_story_loc.x, rss_article_story_loc.y + (i * 15), current_story[rss_article_line_startindex + i], rss_article_color)
     end
    end
  end
      
end

function draw_update()
      if rss_feeds.Data ~= nil then
        offscreen:blit(0, 0, theme_bg)
        
        offscreen:blit(rss_update_bg_loc.x, rss_update_bg_loc.y, theme_article_bg)
    
        offscreen:fontPrint(rss_update_font, rss_update_feedtitle_loc.x, rss_update_feedtitle_loc.y, "Updating:", Black)
        offscreen:fontPrint(rss_update_font, rss_update_feedtitle_loc.x + 75, rss_update_feedtitle_loc.y, rss_feeds.Data[current_update].Title, Black)
        offscreen:fontPrint(rss_update_font, rss_update_feedurl_loc.x, rss_update_feedurl_loc.y, rss_feeds.Data[current_update].url .. "/" .. rss_feeds.Data[current_update].file, Black)
        
        if update_status == status_init then
          offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Initializing...", Black)              
        elseif update_status == status_idle then
          offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Idle...", Black)              
        elseif update_status == status_connect then
          offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Connecting...", Black)              
        elseif update_status == status_dl then
          if current_totalsize ~= 0 then
            offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Downloading ... " .. current_size .. "/" .. current_totalsize, Black)
            offscreen:fontPrint(rss_update_font, rss_update_percent_loc.x, rss_update_percent_loc.y, "Percent: " .. current_percent, Black)
            offscreen:fontPrint(rss_update_font, rss_update_kbps_loc.x, rss_update_kbps_loc.y, "kbps: " .. current_kbps, Black)
            offscreen:fontPrint(rss_update_font, rss_update_timeleft_loc.x, rss_update_timeleft_loc.y, "Time Left: " .. current_timeleft, Black)
          else
            offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Downloading ... " .. current_size, Black)
            offscreen:fontPrint(rss_update_font, rss_update_percent_loc.x, rss_update_percent_loc.y, "Percent: n/a", Black)
            offscreen:fontPrint(rss_update_font, rss_update_kbps_loc.x, rss_update_kbps_loc.y, "kbps: " .. current_kbps, Black)
            offscreen:fontPrint(rss_update_font, rss_update_timeleft_loc.x, rss_update_timeleft_loc.y, "Time Left: n/a", Black)
          end
        elseif update_status == status_save then
          offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Saving...", Black)              
        elseif update_status == status_abort then
          offscreen:fontPrint(rss_update_font, rss_update_status_loc.x, rss_update_status_loc.y, "Aborting...", Black)
        end
        offscreen:fontPrint(rss_update_font, rss_update_abort_loc.x, rss_update_abort_loc.y, "Press O to abort", Black)
      end

    -- progress bar
    -- os:fillRect(fw*2,(fw*6)+10,100*1.5,fw,yellow)
    -- os:fillRect(fw*2,(fw*6)+10,math.floor(per)*1.5,fw,red)      

    -- os:print(fw*2,fw*5, System.powerGetBatteryLifePercent() .. '% battery remaining',yellow)

    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
    
end